
#include <asm/asm.h>
#include <asm/regdef.h>
#include <asm/cacheops.h>
#include <asm/mipsregs.h>

#ifdef CONFIG_TIVO_NGP0
#include <asm/bcm7020.h>
#endif

#ifdef CONFIG_TIVO_UMA2C
#ifdef CONFIG_TGC
#include <asm/bcm7318.h>
#else
#include <asm/bcm7315.h>
#endif
#endif

#ifdef CONFIG_TIVO_EIGER
#include <asm/bcm7038.h>
#endif

#ifdef CONFIG_TIVO_FUSION
#include <asm/bcm7401.h>
#endif

#define CACHE_WRITETHRU                 0x1
#define CACHE_DISABLE                   0x2
#define CACHE_WRITEBACK                 0x3

		.text
LEAF(turnoff_caches)
	.set push
	.set noreorder

    mtc0    zero, CP0_CONFIG
     nop

	jr      ra
	 nop

	.set pop

END(turnoff_caches)

LEAF(turnon_caches)
	.set push
	.set noreorder

    addiu   sp, sp, -8
    sw      t0, 0(sp)

	li	    t0, 0xC3000000	/* ICE | DCE | DSUP | DCP */
	mtc0	t0, CP0_CONFIG
     nop

    lw      t0, 0(sp)
    addiu   sp, sp, 8

	jr      ra
	 nop

	.set pop

END(turnon_caches)

LEAF(clear_caches)
	.set push
	.set noreorder

    addiu   sp, sp, -8
    sw      ra, 0(sp)

	jal     invalidate_icache
	 nop

	jal     invalidate_dcache
	 nop

    lw      ra, 0(sp)
    addiu   sp, sp, 8

	jr      ra
	 nop

	.set pop

END(clear_caches)


LEAF(invalidate_icache)
	.set push
	.set noreorder

    addiu   sp, sp, -8
    sw      t0, 0(sp)

	mtc0    zero, CP0_TAGLO
	 nop
	mtc0    zero, CP0_TAGHI
	 nop

	li      t0, KSEG0 | ICACHE_SIZE
	sub     t0, t0, ICACHE_LINESIZE

1:
	.set push
    .set mips3
	cache  Index_Store_Tag_I, 0x0(t0)
	.set pop
	
	bne     t0, KSEG0, 1b
	 subu    t0, t0, ICACHE_LINESIZE

    lw      t0, 0(sp)
    addiu   sp, sp, 8

	jr      ra
	 nop

	.set pop

END(invalidate_icache)


LEAF(invalidate_dcache)
	.set push
	.set noreorder

    addiu   sp, sp, -8
    sw      t0, 0(sp)

	mtc0    zero, CP0_TAGLO
	 nop
	mtc0    zero, CP0_TAGHI
	 nop

	li      t0, KSEG0 | DCACHE_SIZE
	subu    t0, t0, DCACHE_LINESIZE

1:
	.set push
    .set mips3
	cache   Index_Store_Tag_D, 0x0(t0)
	.set pop

	bne     t0, KSEG0, 1b
	 subu    t0, t0, DCACHE_LINESIZE

    lw      t0, 0(sp)
    addiu   sp, sp, 8

	jr      ra
	nop

	.set pop
END(invalidate_dcache)
