/*
 * Arch-specific bits for process log
 * 
 * Copyright (C) 2001 TiVo, Inc. All Rights Reserved.
 */

#include <linux/errno.h>
#include <linux/kernel.h>
#include <asm/unistd.h>

#define SYS(x,y) #x,

static const char *syscall_names[] = {
#include "syscall_names.h"
};

#define NUM_NAMES (sizeof(syscall_names) / sizeof(syscall_names[0]))

int plog_print_syscall(int num)
{
    if (num < __NR_Linux || num > (__NR_Linux + NUM_NAMES)) {
        return -EINVAL;
    }
    printk(syscall_names[ num - __NR_Linux ]);
    return 0;
}
